Subject: bug#40407: [PATCH] slow ENCODE_FILE and DECODE_FILE

From: Eli Zaretskii <[email-masked]>
Date: Sun, 05 Apr 2020 06:42:51 +0300

On April 5, 2020 5:37:03 AM GMT+03:00, Eli Zaretskii <[email-masked]> wrote:
> > From: Mattias Engdegård <[email-masked]>
> > Date: Sat, 4 Apr 2020 20:06:23 +0200
> > Cc: [email-masked]
> > 
> > 4 apr. 2020 kl. 19.37 skrev Eli Zaretskii <[email-masked]>:
> > 
> > > Btw, if we want this particular use case to be as fast as
> possible,
> > > then Fcopy_sequence is not the best way, because it is not
> optimized
> > > for the case of copying a single string.  We could do better by
> > > calling make_uninit_multibyte/unibyte_string and memcpy directly.
> > 
> > Yes, if that would provide a benefit. The pattern should probably be
> encapsulated in copy_string or similar, if it doesn't already exist.
> 
> I wouldn't make it a separate function for the benefit of just one
> caller.  Every function call is a slowdown, albeit a small one.

However, we already have those functions ready, see make_unibyte_string and make_multibyte_string.